#include "C:\hashing\fixlen.cpp"
// abstract class designed to support fixed field records
// Use of this class requires that all fields be defined before
// reading and writing can take place
class FixedFieldBuffer : public FixedLengthBuffer
{
  public:
   FixedFieldBuffer (int maxFields, int RecoredSize = 1000);
   FixedFieldBuffer (int maxFields,int * fieldSize);
   // initialize all fields at once
   FixedFieldBuffer (const FixedFieldBuffer &); // copy constructor
   FixedFieldBuffer & operator = (const FixedFieldBuffer &);
   void Clear();  // clear values from buffer
   int AddField(int fieldSize); // define the next field
   int ReadHeader(istream &);    // read the header
   int WriteHeader(ostream &) const;   // write the header
   int Pack (const void * field, int size = -1);
   // set the value of the next field of the buffer
   int Unpack (void * field, int maxBytes = -1);
   // extract the value of the next field of the buffer
   void Print(ostream &) const;
   int NumberOfFields () const; // return number of defined fields
   int Init (int maxFields);
   int Init (int numFields, int * fieldSize);

  protected:
   int *FieldSize;  //array to hold field sizes
   int MaxFields;  // max number of fields
   int NumFields;  // actual number of defined fields
   int NextField;  //index of next field to be packed/unpacked
};

inline FixedFieldBuffer :: FixedFieldBuffer (const FixedFieldBuffer & buffer)
  :FixedLengthBuffer (buffer)
{
   Init(buffer.NumFields, buffer.FieldSize);
}


