#include "C:\hashing\buffile.cpp"
// abstract class designed to support fixed length records
class FixedLengthBuffer:public IOBuffer
{
   public:
    FixedLengthBuffer (int recordSize = 1000);
    FixedLengthBuffer (const FixedLengthBuffer & buffer);
    // copy constructor
    void Clear();      // clear values from buffer
    int Read (istream &);
    int Write (ostream &) const;
    int ReadHeader (istream &);   // read the header
    int WriteHeader (ostream &) const;  // write the header
    void Print (ostream &) const;
    int SizoOfBuffer () const;
   protected:
    int Init(int recordSize);
    int ChangeRecordSize (int recordSize);
};

inline FixedLengthBuffer::FixedLengthBuffer (const FixedLengthBuffer& buffer)
	   : IOBuffer(buffer)
{
    Init(buffer.BufferSize);
}

