#include<stdio.h>
#include<iostream.h>
#include<string.h>
#include<conio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<fstream.h>
#include<dos.h>
char ur[20];
#define true 1
#define false 0
int f = 0; // f = 0 means record deleted else it has been modified
int find(char *u, fstream &file);
// Class No.1:
class iobuf
 // An Abstract base class for file buffers
 {
 public:

	iobuf(int maxby=1000);  // a maximun of maxby
	iobuf & operator = ( const iobuf& );

	virtual void clear();    // clear fields from buffer

	virtual int pack( const void* field, int size=-1 )=0;
	// set the value of the next field of the buffer
	virtual int unpack( void * field, int maxby=-1)=0;
	// extract the value of the next field of the buffer

	virtual void print(ostream&) const;
	int init(int maxby);
	// the read and write methods return the address of the record
	// sequential read and write operations

	virtual int read( istream& )=0;
	// read a buffer from the stream
	virtual int write( ostream& ) const=0;
	// write a buffer to the stream

 protected:
	int inital;    // TRUE if buffer is initilized
	char * buf;   // char array to hold field values
	int bufsiz;   // sum of the sizes of packed values
	int maxby;    // maximum number of char in the buffer
	int nextby;   // index of next byte to be packed/unpacked
	int packing;  // TRUE if in packing mode, FALSE, if unpacking
 };

//IOBUF functions

iobuf::iobuf ( int maxby )
 {
	// construct with max of maxFields
	init(maxby);
 }

iobuf & iobuf :: operator = ( const iobuf& Buf )
 {
	if( maxby < Buf.bufsiz )     // fails
		return *this;

	inital=Buf.inital;
	bufsiz=Buf.bufsiz;
	memcpy(buf,Buf.buf,Buf.bufsiz);
	nextby=Buf.nextby;
	packing=Buf.packing;	//Doubt
	return *this;
 }

void iobuf :: clear ()
 // clear field values from buffer
 {
	nextby=0;	packing=true;
 }

void iobuf :: print( ostream & str ) const
 {
	str<<"Maxbytes"<<maxby<<"Buffersize " <<bufsiz;
 }


int iobuf :: init ( int Maxby )
 {
	inital=false;

	if( Maxby < 0 )
		Maxby=0;
	maxby=Maxby;

	buf=new char[maxby];
	bufsiz=0;
	clear();
	return 1;
 }

//Class No.2

class varbuf : public iobuf
 // Abstract class designed to support variable length records
 // Fields may be of a variety of type
 {

 public:
	varbuf(int maxby=1000);
	varbuf(const varbuf& buf):iobuf(buf){}; // copy constructor
	void clear(); // clear fields from buffer

	int read(istream &);
	int write(ostream &) const;

	void print(ostream&) const;

	int pack( void *, int );	//doubt
	int sizofbuf() const;           // return current size of buffer
	int init();
 };

 //varbuf Functions

varbuf :: varbuf ( int Maxby ) : iobuf( Maxby )
 // construct with a maximum of maxFields
 {
	init();
 }

void varbuf :: clear () // clear fields from buffer
 {
	iobuf::clear();
 }

int varbuf :: read ( istream & str )
// write the number of bytes in the buffer field definitions
// the record length is represented by an unsigned short value
 {
	if ( str.eof() )
		return -1;

	int recaddr=str.tellg();
	clear();

	unsigned short buf_siz;
	str.read( (char*)&buf_siz, sizeof(buf_siz) );
	if( !str.good() )
	 {
		str.clear();
		return -1;
	 }
	bufsiz=buf_siz;

	if(bufsiz>maxby)   // buffer overflow
		return -1;

	str.read( buf, bufsiz );
	if( !str.good() )
	 {
		str.clear();
		return -1;
	 }
	return recaddr;
 }

int varbuf :: write ( ostream & str ) const
// write the length and buffer into the stream
 {
	int recaddr=str.tellp();

	unsigned short buf_siz;
	buf_siz=bufsiz;

	str.write( (char*)&buf_siz, sizeof(buf_siz) );

	if( !str )
		return -1;

	str.write( buf, bufsiz );
	if( !str.good() )
		return -1;
	return recaddr;
 }

void varbuf :: print ( ostream & str ) const
 {
	iobuf::print(str);
 }

int varbuf :: init ()   // construct with a max of maxFields
 {
	clear();
	return true;
 }

//Class No.3

class Delimbuf : public varbuf
 {
// a buffer which holds a delimited text fields
 public:
	Delimbuf(char delim=-1, int maxby=1000);
	// construct with a max of maxBytes
	// construct with a fields with delimeters
	Delimbuf(const Delimbuf& buf) : varbuf(buf){};
	// copy constructor
	void clear();      // clear fields from buffer

	int pack( const void *field, int size=-1);
	// set the value of the next field of the buffer
	int unpack( void *field, int maxby=-1);
	// extract the value of the next field of the buffer
	int getsiz()	{return bufsiz;}

	void print(ostream&) const;

	int init(char delim=0);
	static void setdefaultdelim(char delim);

 protected:
	char delim;
	static char defaultdelim;
 };

char Delimbuf :: defaultdelim='|';


// Delimbuf functions

Delimbuf :: Delimbuf(char delim, int Maxby) : varbuf(Maxby)
 {
	init(delim);
 }

void Delimbuf :: clear () // clear fields from buffer
 {
	varbuf::clear();
 }

int Delimbuf :: pack(const void *field,int size)
// set the value of the next field of the buffer
// if size = -1 (default) use strlen(field) as Delim of field
// return number of bytes packed, -1 error
 {
	short len ;  // length of a string to be packed
	if(size >= 0)
		 len = size;
	else
		len = strlen((char*)field);
	if(len > (short)strlen((char*)field)) // field is too short
	 return -1;
	int start = nextby;   // first char to be packed
	nextby += len +1;
	if(nextby>maxby)
		return -1;
	memcpy(&buf[start],field,len);
	buf[start+len]=delim;  // add a delimiter
	bufsiz = nextby;

	return len;
 }

 int Delimbuf :: unpack(void * field,int Maxby)
 // extract the value of the next field of the buffer
 // return the number of bytes extracted, -1 if error
 {
	short len=-1;    // length of packed string
	int start = nextby;  // first char to be unpacked

	for ( int i=start;i<bufsiz;i++ )
		if ( buf[i]==delim )
		 {
			len=i-start;
			break;
		 }
	if(len == -1) return -1; // delimiter not found
	nextby += len + 1;
	if(nextby > bufsiz)
		return -1;
	// check for maxByte
	memcpy(field,&buf[start],len);
	if(Maxby>len|| Maxby == -1)
		((char*) field)[len] = 0;  //zero terminating for string

	return len;
 }

 void Delimbuf :: print(ostream & str) const
 {
	varbuf::print(str);
	str<<"Delimeter : "<<delim<<"\n";
 }
// protected members
 int Delimbuf :: init(char Del)
 // construct with a maximum of maxFields
 {
	inital = true;
	clear();
	if(Del==-1)
		delim=defaultdelim;
	else
		delim=Del;
	return true;
 }

void Delimbuf :: setdefaultdelim( char del )
 {
	defaultdelim=del;
 }

// initilize static protected element
//char Delimbuf :: defaultdelim = 0;

//Class No.4
class stud
 {
	char name[25];
	char urn[20];
	char addr[30];
	char sem[10];
	char brn[10];

	//functions
  public:
	stud();
       //	char urn[20];
	void getdata();
	int pack(Delimbuf &);
	int unpack(Delimbuf &);
	void dis();

	void setname(char *);
	void setadd(char *);
	void setsem(char *);
	void setbrn(char *);
	void seturn(char *);
	void mod();

	char* geturn()  {return urn; }
	char* getname()	{return name;}
	char* getadd() 	{return addr;}
	char* getsem() 	{return sem; }
	char* getbrn()	{return brn; }

	stud & operator = ( stud & );

 };

//functions of student class

stud :: stud ()
 {
	strcpy(name,"");	strcpy(urn,"");
	strcpy(addr,"");	strcpy(sem,"");
	strcpy(brn,"");
 }

void stud :: getdata ()
 {
	int len=0;
	clrscr();
	cout<<"\n\nEnter the name  : ";	gets(name);	len=strlen(name);
       //	cout<<"Enter the urn   : ";	cin>>urn;
	strcpy(urn,ur);
	len+=strlen(urn);

	cout<<"Enter the addr  : ";	gets(addr);	len+=strlen(addr);
	cout<<"Enter the sem   : ";	cin>>sem;       len+=strlen(sem);
	cout<<"Enter the branch: ";	cin>>brn;       len+=strlen(brn);

	len+=5;
	if(len==13 | len==10)
		strcat(brn," ");
 }

int stud :: pack ( Delimbuf & buffer )
 {
	int res;

	buffer.clear();
	res=buffer.pack(name);
	res=res && buffer.pack(urn);
	res=res && buffer.pack(addr);
	res=res && buffer.pack(sem);
	res=res && buffer.pack(brn);

	return res;
 }

int stud :: unpack ( Delimbuf & buffer )
 {
	int res;

	res=buffer.unpack(name);
	res=res && buffer.unpack(urn);
	res=res && buffer.unpack(addr);
	res=res && buffer.unpack(sem);
	res=res && buffer.unpack(brn);

	return res;
 }

void stud :: dis ()
 {
	cout<<"\nName    : "<<name;
	cout<<"\nURN     : "<<urn;
	cout<<"\nAddress : "<<addr;
	cout<<"\nSemester: "<<sem;
	cout<<"\nBranch  : "<<brn;
 }

stud & stud :: operator = ( stud & s1 )
 {
	strcpy(name,s1.getname());
	strcpy(addr,s1.getadd());
	strcpy(sem,s1.getsem());
	strcpy(brn,s1.getbrn());

	return (*this) ;
 }

void stud :: setname( char * nam)
 {
	strcpy(name,nam);
	return;
 }

void stud :: setadd( char * ad )
 {
	strcpy(addr,ad);
	return;
 }

void stud :: setsem( char * se )
 {
	strcpy(sem,se);
	return;
 }

void stud :: setbrn ( char * br )
 {
	strcpy(brn,br);
	return;
 }

void stud :: seturn ( char * ur )
 {
	strcpy(urn,ur);
	return;
 }
void stud :: mod ( )
 {
	strcat(brn," ");
 }

// main

Delimbuf Dbuf;
stud st;

void main()
 {
       //	char ur[20];
	stud st;
	fstream file;

	void modify(char *,fstream &);
	void display(char *,fstream &);
	void delet(char *,fstream &);
	void viewall(fstream & );
	void create(fstream & );
	void assign(fstream & );

	clrscr();

	gotoxy(25,10);
	cprintf("STUDENT RECORD MANAGEMENT.\n\n");
	gotoxy(26,20);
	cout<<"\t\t\t\t\tDeveloped by : \n";
	cout<<"\t\t\t\t\t\t\t\t Manjunath.J \n\t\t\t\t\t\t\t\t\t& \n\t\t\t\t\t\t\t\t Ravi V Hodlur.\n";
	getch();
	clrscr();

	while(1)
	 {
		delay(250);
		clrscr();
		cout<<"\n\nEnter your choice.\n\n";
		cout<<"1 : Create record.\n2 : Modify Record.\n3 : View record.\n4 : Delete Record.\n5 : View all.\n6 : Assign a record.\n7 : Exit\n\n";

		int ans; 	cin>>ans;

		switch(ans)
		 {
			case 1: file.open("stud.doc",ios::in|ios::out|ios::app);
				cout<<"\nEnter the urn.\n";
				cin>>ur;
				if(find(ur,file))
					{

						create(file);

					}
				else cout<<"Record Already Exists"<<endl;
				file.close();
				getch();
				break;

			case 2:	cout<<"\nEnter the urn.\n";
				cin>>ur;

				file.open("stud.doc",ios::in|ios::out );
				modify(ur,file);
				file.close();

				break;

			case 3: cout<<"Enter the urn.\n";
				cin >> ur;

				file.open("stud.doc",ios::in);
				display(ur,file);
				file.close();

				break;

			case 4: cout<<"Enter the urn.\n";
				cin >> ur;

				file.open("stud.doc",ios::in|ios::out);
				delet(ur,file);
				file.close();

				break;

			case 5: file.open("stud.doc",ios::in);
				viewall(file);
				file.close();

				break;

			case 6: file.open("stud.doc",ios::in|ios::out);
				assign(file);
				file.close();

				break;

			default:remove("stud.doc");
				cout<<"Thank You"<<endl;
				getch();
				exit(0);
		 }
	 }
 }

//Main functions

void display ( char * ur, fstream & file )
 {
	int i;
	char *URN,*nam;

	while( Dbuf.read(file) !=-1 )
	 {
		st.unpack(Dbuf);

		URN=st.geturn();	nam=st.getname();
		if( (strcmp(URN,ur)==0) && (strstr(nam,"*")==NULL) )
		 {
			cout<<"Record Found.\n";
			st.dis();
			getch();
			return;
		 }
	 }

	cout << "Record not found!!!\n";
	getch();
	return;
 }

int find(char *u, fstream &file)
{
   int recaddr;
   char * URN,*nam;
   while((recaddr =Dbuf.read(file)) != -1)
   {
     st.unpack(Dbuf);
    // getch();
     URN = st.geturn();  nam = st.getname();
     if ( (strcmp(URN,u) == 0) && (strstr(nam,"*")==NULL))
     return 0; //record found

   }
  return 1; //record not found

}
void delet( char * u, fstream &file )
 {
	int i,recaddr;
	char * URN, *nam,*temp;
	while( ( recaddr=Dbuf.read(file)) !=-1 )
	 {
		st.unpack(Dbuf);
      //		getch();
		URN=st.geturn();	nam=st.getname();
		if( (strcmp(URN,u)==0) && (!strstr(nam,"*")) )
		 {

			int len=strlen(nam);	//adding as many *s as the
			for(i=0;i<len;i++)	//length of 'name'
				temp[i]='*';
			temp[i]='\0';

			strcpy(nam,temp);
			st.pack(Dbuf);
			file.seekp(recaddr,ios::beg);
			Dbuf.write(file);
			if(f == 0)
				cout<<"Record Deleted Successfully"<<endl;
			else
				cout<<"Record Modified Successfully"<<endl;
			f = 0;
			getch();
			return;
		 }

	 }

	cout<<"Record Not Found!!\n\n";
	getch();
	return;
 }

void viewall ( fstream & file )
 {
	int i=0;
	char * nam;

	while( Dbuf.read(file)!=-1 )
	 {
		st.unpack(Dbuf);

		nam=st.getname();
		if( !(strstr(nam,"*")) )   // skip deleted record
		 {
			cout<<"\n\n************\n";
			cout<<"Record # : "<<++i;
			cout<<"\n************\n";
			st.dis();
			getch();
		 }
	 }
 }

void create ( fstream & file )
 {
	stud st;
	st.getdata();
	st.pack(Dbuf);

	int rec=Dbuf.write(file);
	if(rec!=-1)
		cout<<"\nRecord Written";
	getch();
	return;
  }

void modify( char * ur, fstream & file )
 {
	char * UR, *nam;
	int recaddr;
	clrscr();

	while( (recaddr=Dbuf.read(file)) !=-1 )
	 {
		st.unpack(Dbuf);

		UR=st.geturn();		nam=st.getname();
		if( (strcmp(ur,UR)==0) && (!strstr(nam,"*")) )
		 {
			int len=Dbuf.getsiz();

			while(1)
			 {
				clrscr();
				cout<<"The record is : \n";
				st.dis();

				cout<<"\n\nWhich field do u want to modify ?\n";
				cout<<"1 : Name.\n2 : Addr.\n3 : Sem.\n4 : Branch.\n5 : Main menu.\n\n";
				int  a;		cin>>a;

				switch(a)
				 {
					case 1:	cout<<"Enter the new name : ";
						gets(nam);
						st.setname(nam);
						break;

					case 2:	cout<<"Enter the new address : ";
						char * ad;	cin>>ad;
						st.setadd(ad);
						break;

					case 3: cout<<"Enter the new sem : ";
						char * se; 	cin>>se;
						st.setsem(se);
						break;

					case 4: cout<<"Enter the new branch : ";
						char * br;	cin>>br;
						st.setbrn(br);
						break;

					default:f = 1; // set to modify
						st.pack(Dbuf);
						int len2=Dbuf.getsiz();

						if(len2==13 || len2==10)
						 {
							st.mod();
							st.pack(Dbuf);
						 }
						len2=Dbuf.getsiz();
						if( len == len2 )
						 {
							file.seekp(recaddr,ios::beg);
							Dbuf.write(file);
						 }
						else
						 {
							file.close();
							file.open("stud.doc",ios::app);
							Dbuf.write(file);
							file.close();
							file.open("stud.doc",ios::in|ios::out);
							delet(ur,file);
						 }

						return;
				 }
			 }
		 }
	 }

	cout<<"Record Not Found!!\n";
	return;
 }

void assign ( fstream & file )
 {
	stud s1,s2;
	char *UR,*nam;
	int recaddr;

	cout<<"Enter the urn of the student record \"from\" which, assignment is to be made : ";
	char * u1;	cin>>u1;
	cout<<"\nEnter the urn of the student record \"to\" which assignment is to be made : ";
	char * u2;	cin>>u2;

	if( !strcmp(u1,u2) )   // check for similarity
	 {
		cout<<"\nThe two records are same!!!\n";
		delay(350);
		return;
	 }

	while( (recaddr=Dbuf.read(file)) !=-1 )  // while not EOF
	 {
		s1.unpack(Dbuf);   // unpack

		UR=s1.geturn();	nam=s1.getname();
		if( (strcmp(u1,UR)==0) && (!strstr(nam,"*")) )
			break;

	 }
	if( recaddr==-1 ) // record not found
	 {
		cout<<"\nThe record with urn "<<u1<<" does not exist.\n\n";
		return;
	 }
	file.close();
	file.open("stud.doc",ios::in|ios::out);  // assign the record

	while( (recaddr=Dbuf.read(file)) !=-1 )
	 {
		s2.unpack(Dbuf);

		UR=s2.geturn();		nam=s2.getname();
		if( (strcmp(u2,UR)==0) && (!strstr(nam,"*")) )
		 {
			s2=s1;
			s2.seturn(u2);
			file.seekp(recaddr,ios::beg);
			s2.pack(Dbuf);         // pack
			Dbuf.write(file);
			break;
		 }
	 }
	if( recaddr==-1 )
	 {
		cout<<"\nRecord with urn "<<u2<<" does not exist.\nDo you want to create one ?\n";
		char ans='y';	cin >> ans;
		if( ans == 'y' )
		 {
			s2=s1;
			s2.seturn(u2);
			s2.pack(Dbuf);
			Dbuf.write(file);
		 }
		else
			return;
		cout<<"\nThe 2 records are : \n\n";
		s1.dis();	cout<<"\n\n";
		s2.dis();
		getch();
	 }
 }

//end